## ----echo=FALSE----------------------------------------------------------
results = "hide"; echo = FALSE

## ----setup, include=FALSE, cache=FALSE----------
library(knitr)
options(replace.assign=FALSE,width=50)

opts_chunk$set(fig.path='figure/graphics-', 
               cache.path='cache/graphics-', 
               fig.align='center', 
               dev='pdf', fig.width=5, fig.height=5, 
               fig.show='hold', cache=FALSE, par=TRUE)
knit_hooks$set(crop=hook_pdfcrop)

knit_hooks$set(par=function(before, options, envir){
  if (before && options$fig.show!='none') {
    par(mar=c(3,3,2,1),cex.lab=.95,cex.axis=.9,
        mgp=c(2,.7,0),tcl=-.01, las=1)
  }}, crop=hook_pdfcrop)

## -----------------------------------------------
library("nclRintroduction")

## -----------------------------------------------
x1 = GetNumericVector()

## ----echo=echo, results=results-----------------
length(x1)

## ----echo=echo, results=results-----------------
x1[55]

## ----echo=echo, results=results-----------------
x1[length(x1)]

## ----echo=echo, results=results-----------------
mean(x1)

## ----echo=echo, results=results-----------------
min(x1)

## ----echo=echo, results=results-----------------
q1 = quantile(x1)[2]
med = median(x1)
length(x1[x1 > q1 & x1 < med])
##Or
sum(x1 > q1 & x1 < med)

## ----echo=echo, results=results-----------------
length(x1[x1 > (mean(x1) + 2*sd(x1))])
##Or
sum(x1 > (mean(x1) + 2*sd(x1)))

## ----echo=echo, results=results-----------------
sort(x1)[50]

## -----------------------------------------------
y = GetDataFrame()

## ----echo=echo, results=results-----------------
dim(y)[1]
## Or
nrow(y)

## ----echo=echo, results=results-----------------
dim(y)[2]
## Or
ncol(y)

## ----echo=echo, results=results-----------------
nrow(y[y$Budget != -1,])
##Or
sum(y$Budget != -1)

## ----echo=echo, results=results-----------------
nrow(y[y$Rating < 2.5 | y$Rating > 7.5,])
##
sum(y$Rating < 2.5 | y$Rating > 7.5)

## ----echo=echo, results=results-----------------
nrow(y[y$Length > 120 & y$Rating > 7.5,])
##Or
sum(y$Length > 120 & y$Rating > 7.5)

## ----echo=echo, results=results-----------------
nrow(y[y$Year == 1980 & y$Rating > 5.0,])
##Or
sum(y$Year == 1980 & y$Rating > 5.0)

## ----echo=echo, results=results-----------------
sum(y$Action)

## ----echo=echo, results=results-----------------
sum(y$Action == 1 & y$Animation == 1)

## -----------------------------------------------
x2 = GetCharacterVector()

## ----echo=echo, results=results-----------------
length(x2[x2=="A"])
##Or
sum(x2=="A")

## ----echo=echo, results=results-----------------
sort(table(x2))[1]

## ----echo=echo, results=results-----------------
l = length(x2)
x2_a = x2[1:(l-1)]; x2_b = x2[2:l];
sum(x2_a == x2_b) 

## ----eval=FALSE---------------------------------
#  library(nclRintroduction)
#  vignette("solutions2", package="nclRintroduction")

